<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'startDate',
    label: '申请查询的数据的开始日期',
    component: 'DatePicker',
    componentProps: {
      style:"width:100%;",
      format:"YYYY-MM-DD",
      valueFormat:"YYYY-MM-DD"
    },
    colProps:{
      span:24,
    }
  },
  {
    field: 'endDate',
    label: '申请查询的数据的结束日期',
    component: 'DatePicker',
    componentProps: {
      style:"width:100%;",
      format:"YYYY-MM-DD",
      valueFormat:"YYYY-MM-DD"
    },
    colProps:{
      span:24,
    }
  },
  {
    field: 'proposer',
    label: '申请人',
    component: 'Input',
    colProps:{
      span:24,
    }
  },
  {
    field: 'checkDepartment',
    label: '申请单位及文号',
    component: 'Input',
    colProps:{
      span:24,
    }
  },
  {
    field: 'applydate',
    label: '申请日期',
    component: 'DatePicker',
    componentProps: {
      style:"width:100%;",
      format:"YYYY-MM-DD",
      valueFormat:"YYYY-MM-DD"
    },
    colProps:{
      span:24,
    }
  },
  {
    field: 'organIds',
    label: '所属机构',
    component: 'Select',
    componentProps: {
      
    },
    colProps:{
      span:24,
    }
  },
  {
    field: 'tableName',
    label: '申请生成的表',
    component: 'Select',
    componentProps: {
      
    },
    colProps:{
      span:24,
    }
  },
])

const rules = reactive({
  startDate:[required()],
  endDate:[required()],
  proposer:[required()],
  checkDepartment:[required()],
  applydate:[required()],
  organIds:[required()],
  tableName:[required()],
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

